// ReceiverDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Receiver.h"
#include "ReceiverDlg.h"
#include "Bthutils.h"
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CReceiverDlg dialog


//portul serial
HANDLE hSerialPort;

//SDP record generated by bthnscreate.exe
BYTE rgbSdpRecord[] = {
	0x35, 0x4d, 0x09, 0x00, 0x01, 0x35, 0x11, 0x1c,
	0x29, 0xf9, 0xc0, 0xfd, 0xbb, 0x6e, 0x47, 0x97,
	0x9f, 0xa9, 0x3e, 0xc9, 0xa8, 0x54, 0x29, 0x0c,
	0x09, 0x00, 0x04, 0x35, 0x0c, 0x35, 0x03, 0x19,
	0x01, 0x00, 0x35, 0x05, 0x19, 0x00, 0x03, 0x08,
	0x1a, 0x09, 0x00, 0x06, 0x35, 0x09, 0x09, 0x65,
	0x6e, 0x09, 0x00, 0x6a, 0x09, 0x01, 0x00, 0x09,
	0x00, 0x09, 0x35, 0x08, 0x35, 0x06, 0x19, 0x11,
	0x05, 0x09, 0x01, 0x00, 0x09, 0x01, 0x00, 0x25,
	0x06, 0x53, 0x65, 0x72, 0x69, 0x61, 0x6c
};

//server GUID
WCHAR strGUID[]=L"29F9C0FD-BB6E-4797-9FA9-3EC9A854290C";

//SDP record size constant returned by bthnscreate.exe
#define SDP_RECORD_SIZE 0x0000004f
#define SDP_CHANNEL_OFFSET 40

#define SENDER 1
#define RECEIVER 2

BthUtils objBth;
int g_iMode = RECEIVER;
int g_iSelectedDeviceIndex;
DeviceInfo *g_pLocalDeviceInfo, *g_pPeerDeviceInfo;

CEdit *g_ceClonedEditBox;
CButton *g_cbClonedUp, *g_cbClonedDown, *g_cbClonedLeft, *g_cbClonedRight, *g_cbClonedCenter;


CReceiverDlg::CReceiverDlg(CWnd* pParent /*=NULL*/)
: CDialog(CReceiverDlg::IDD, pParent)
, csEditBox(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CReceiverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_EDIT_MSG, ceEditBoxMsg);		
	DDX_Control(pDX, IDC_CHECK_UP, cbtnUp);
	DDX_Control(pDX, IDC_CHECK_CENTER, cbtnCenter);
	DDX_Control(pDX, IDC_CHECK_DOWN, cbtnDown);
	DDX_Control(pDX, IDC_CHECK_RIGHT, cbtnRight);
	DDX_Control(pDX, IDC_CHECK_LEFT, cbtnLeft);
}

BEGIN_MESSAGE_MAP(CReceiverDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_INIT, &CReceiverDlg::OnBnClickedButtonInit)		
END_MESSAGE_MAP()


// CReceiverDlg message handlers

BOOL CReceiverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CReceiverDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_RECEIVER_DIALOG_WIDE) : 
		MAKEINTRESOURCE(IDD_RECEIVER_DIALOG));
	}
}
#endif



void ProcessRecvData(WCHAR *szMessage)
{	
	g_ceClonedEditBox->SetWindowTextW(szMessage);
	if (!wcscmp(szMessage, L"UP"))
	{
		g_cbClonedUp->SetCheck((g_cbClonedUp->GetCheck() + 1) % 2);
	}
	else if (!wcscmp(szMessage, L"DOWN"))
	{
		g_cbClonedDown->SetCheck((g_cbClonedDown->GetCheck() + 1) % 2);
	}
	else if (!wcscmp(szMessage, L"CENTER"))
	{
		g_cbClonedCenter->SetCheck((g_cbClonedCenter->GetCheck() + 1) % 2);
	}
	else if (!wcscmp(szMessage, L"LEFT"))
	{
		g_cbClonedLeft->SetCheck((g_cbClonedLeft->GetCheck() + 1) % 2);
	}
	else if (!wcscmp(szMessage, L"RIGHT"))
	{
		g_cbClonedRight->SetCheck((g_cbClonedRight->GetCheck() + 1) % 2);
	}	
}


void CReceiverDlg::OnBnClickedButtonInit()
{
	int result;	

	g_ceClonedEditBox = &ceEditBoxMsg;	
	
	objBth.DiscoverDevices();		
	result = objBth.OpenServerConnection(rgbSdpRecord, SDP_RECORD_SIZE, SDP_CHANNEL_OFFSET, ProcessRecvData);
	if (result)
		AfxMessageBox(L"Initialization FAILED!");
	else
		AfxMessageBox(L"Initialization OK!");

	g_cbClonedCenter = &cbtnCenter;
	g_cbClonedDown = &cbtnDown;
	g_cbClonedUp = &cbtnUp;
	g_cbClonedLeft = &cbtnLeft;
	g_cbClonedRight = &cbtnRight;
}

void MsgBoxErrCode(int err)
{
	wchar_t szErr[50];
	err = GetLastError();
	AfxMessageBox(_itow(err, szErr, 10));
}
